---------------------------
-- lets simplify a bit..
---------------------------
local gf = Glance.Functions
local gv = Glance.Variables
local ga = Glance.Arrays
local gb = Glance.Buttons

---------------------------
-- create the button
---------------------------
gf.AddButton("Emblems","LEFT")
local btn = gb.Emblems
btn.text              = "Emblems"
btn.enabled           = true
btn.events            = {"HONOR_CURRENCY_UPDATE", "KNOWN_CURRENCY_TYPES_UPDATE", "LFG_COMPLETION_REWARD", "PLAYER_MONEY"}
btn.update            = true
btn.tooltip           = true
btn.click             = true
--btn.timer5            = true
btn.menu              = true
btn.save.perCharacter = {["DisplayEmblems"] = {}}
local spc = btn.save.perCharacter
btn.save.allowProfile = true

---------------------------
-- update
---------------------------
function gf.Emblems.update()
	local btn = gb.Emblems
	if btn.enabled and gv.loaded then -- loaded keeps it from launching when defined
		local HEX = ga.colors.HEX
		Glance.Debug("function","update","Emblems")
		local hasEmblems = false
		local BT,TMP = HEX.red.."Emblems",""
		for i=1, GetCurrencyListSize() do
			local name,_,_,_,_,count,_,icon,_ = GetCurrencyListInfo(i)
			if spc.DisplayEmblems[name] then
				local ARR = { strsplit(" ", name) }
				if TMP ~= "" then TMP = TMP.."    |r" end
				for i=1, #ARR do
					TMP = TMP..string.sub(ARR[i], 1, 1)
				end
				if name == "Justice Points" or name == "Valor Points" or name =="Honor Points" then
					if count == 4000 then
						TMP = TMP..": "..HEX.red.."cap"
					elseif count == 0 then
						TMP = TMP..": "..HEX.red..count
					else
						TMP = TMP..": "..HEX.green..count
					end
				else
					if count == 0 then
						TMP = TMP..": "..HEX.red..count
					else
						TMP = TMP..": "..HEX.green..count
					end
				end
				hasEmblems = true
			end
		end
		if hasEmblems then
			BT = TMP
		end
		btn.button:SetText(BT)
		btn.button:SetWidth(btn.button:GetTextWidth())
	end
end

---------------------------
-- tooltip
---------------------------
function gf.Emblems.tooltip()
	Glance.Debug("function","tooltip","Emblems")
	local tooltip = gf.Tooltip
	local hasEmblems = false
	tooltip.Title("Emblems","GLD")
	for i=1, GetCurrencyListSize() do
		local name,_,_,_,_,count,_,icon,_ = GetCurrencyListInfo(i)
		if spc.DisplayEmblems[name] then
			tooltip.Double(name,count,"LBL","GRN")
		else
			tooltip.Double(name,count,"WHT","GRN")
		end
		hasEmblems = true
	end
	if not hasEmblems then
		tooltip.Line("|rYou have no emblems","WHT")
	end
	tooltip.Space()
	tooltip.Line("(Click to open the Currency tab.)","WHT")
	tooltip.Wrap("(Right-Click to change Emblem tracking.)","WHT")
end

---------------------------
-- click
---------------------------
function gf.Emblems.click(self, button, down)
	Glance.Debug("function","click","Emblems")
	if button == "LeftButton" then
		ToggleCharacter("TokenFrame")
	end
end

---------------------------
-- menu
---------------------------
function gf.Emblems.menu(level,UIDROPDOWNMENU_MENU_VALUE)
	Glance.Debug("function","menu","Emblems")
	local HEX = ga.colors.HEX
	level = level or 1
	if (level == 1) then
		gf.setInfo(nil,true,false,true,nil,HEX.white.."Emblems Options","spacer",level,nil)
		gf.setInfo(nil,nil,true,true,nil,HEX.gold.."Display","display",level,nil)
	end
	if (level == 2) then
		if UIDROPDOWNMENU_MENU_VALUE == "display" then
			local checked, func
			for i=1, GetCurrencyListSize() do
				local name,_,_,_,_,count,_,icon,_ = GetCurrencyListInfo(i)
				if spc.DisplayEmblems[name]==true then checked = true else checked = false end
				func = function() if spc.DisplayEmblems[name] then spc.DisplayEmblems[name]=false else spc.DisplayEmblems[name]=true end; gf.Emblems.update() end;
				gf.setInfo(nil,false,false,false,checked,name,name,level,func,nil,true)
			end
		end
	end
end

---------------------------
-- load on demand
---------------------------
if gv.loaded then
	gf.Enable("Emblems")
end