---------------------------
-- lets simplify a bit..
---------------------------
local gf = Glance.Functions
local gv = Glance.Variables
local ga = Glance.Arrays
local gb = Glance.Buttons

---------------------------
-- create the button
---------------------------
gf.AddButton("Mounts","RIGHT")
local btn = gb.Mounts
btn.text              = "      "
btn.enabled           = true
btn.texture.normal    = "Interface\\AddOns\\Glance_Mounts\\mount.tga"
btn.events            = {"COMPANION_LEARNED"}
btn.update            = true
btn.click             = true
btn.tooltip           = true
btn.menu              = true
btn.options           = true
btn.onload            = true
btn.save.perCharacter = {["Mounts"] = {}}
local spc = btn.save.perCharacter

---------------------------
-- commands
---------------------------
gf.AddCommand("Mounts","random","Summon a random mount",function() if IsMounted() then DismissCompanion("MOUNT") else gf.Mounts.summonRandom() end end)
gf.AddCommand("Mounts","random-air","Summon a random flying mount",function() if IsMounted() then DismissCompanion("MOUNT") else gf.Mounts.summonRandomAir() end end)
gf.AddCommand("Mounts","random-land","Summon a random ground mount",function() if IsMounted() then DismissCompanion("MOUNT") else gf.Mounts.summonRandomLand() end end)
gf.AddCommand("Mounts","random-water","Summon a random water mount",function() if IsMounted() then DismissCompanion("MOUNT") else gf.Mounts.summonRandomWater() end end)

---------------------------
-- variables
---------------------------
ga.flightMounts = {
	"hippogryph",
	"gryphon",
	"wind",
	"ashes",
	"dragonhawk",
	"nether",
	"wyrm",
	"drake",
	"mimiron",
	"frostbrood",
	"phoenix",
	"spectral steed",
	"flying",
	"vial of the sands",
	"ebon blade",
	"celestial",
	"headless",
	"flying",
}
ga.specialMounts = {
	"celestial",
	"headless",
	"location",
	"extremely",
	"carpet",
	"machine",
	"rocket",
	"guardian",
	"changes",
}
ga.fastMounts = {
	"very",
	"skill",
	"ebon blade",
}
ga.waterMounts = {
	"seahorse",
	"turtle",
}
ga.alphabet = {
	["a"] = "ae",
	["b"] = "ae",
	["c"] = "ae",
	["d"] = "ae",
	["e"] = "ae",
	["f"] = "fj",
	["g"] = "fj",
	["h"] = "fj",
	["i"] = "fj",
	["j"] = "fj",
	["k"] = "ko",
	["l"] = "ko",
	["m"] = "ko",
	["n"] = "ko",
	["o"] = "ko",
	["p"] = "pt",
	["q"] = "pt",
	["r"] = "pt",
	["s"] = "pt",
	["t"] = "pt",
	["u"] = "uz",
	["v"] = "uz",
	["w"] = "uz",
	["x"] = "uz",
	["y"] = "uz",
	["z"] = "uz",
}
ga.tmpmount = {}
ga.mount = {}
gv.MountScrollIDX = 0


---------------------------
-- update
---------------------------
function gf.Mounts.update(self, event, arg1)
	if event == "COMPANION_LEARNED" then
		gf.Mounts.resetMountList()
		gf.createMenu("Mounts")
	end
end

---------------------------
-- tooltip
---------------------------
function gf.Mounts.tooltip()
	Glance.Debug("function","tooltip","Mounts")
	local tooltip = gf.Tooltip
	local HEX = ga.colors.HEX
	tooltip.Title("Mounts", "GLD")
	tooltip.Line("You have obtained "..HEX.green..GetNumCompanions("MOUNT")..HEX.white.." mounts.","WHT")
	tooltip.Space()
	tooltip.Wrap("(Click to summon a random mount.)","WHT")
	tooltip.Wrap("(Right-Click to show a dropdown menu of available mounts for your skill and location. Select one to mount or dismount.)","WHT")
end

---------------------------
-- click
---------------------------
function gf.Mounts.click(self, button, down)
	Glance.Debug("function","click","Mounts")
	if button == "LeftButton" then
		if IsMounted() then
			DismissCompanion("MOUNT")
		else
			gf.Mounts.summonRandom()
		end
	end
end

---------------------------
-- onload
---------------------------
function gf.Mounts.onload()
	gf.Mounts.resetMountList()
end

---------------------------
-- menu
---------------------------
function gf.Mounts.menu(level,UIDROPDOWNMENU_MENU_VALUE)
	Glance.Debug("function","menu","Mounts")
	local HEX = ga.colors.HEX
	level = level or 1
	if (level == 1) then
		gf.setInfo(nil,true,false,true,nil,HEX.white.."Mounts Options","spacer",level,nil)
		gf.setInfo(nil,nil,true,true,nil,HEX.gold.."Flying","flying",level,nil)
		gf.setInfo(nil,nil,true,true,nil,HEX.gold.."Riding","riding",level,nil)
		gf.setInfo(nil,nil,true,true,nil,HEX.gold.."Swimming","swimming",level,nil)
	end
	if (level == 2) then
		if UIDROPDOWNMENU_MENU_VALUE == "flying" then
			gf.setInfo(nil,nil,true,true,nil,HEX.gold.."Mounts A-E","fae",level,nil)
			gf.setInfo(nil,nil,true,true,nil,HEX.gold.."Mounts F-J","ffj",level,nil)
			gf.setInfo(nil,nil,true,true,nil,HEX.gold.."Mounts K-O","fko",level,nil)
			gf.setInfo(nil,nil,true,true,nil,HEX.gold.."Mounts P-T","fpt",level,nil)
			gf.setInfo(nil,nil,true,true,nil,HEX.gold.."Mounts U-Z","fuz",level,nil)
		end
		if UIDROPDOWNMENU_MENU_VALUE == "riding" then
			gf.setInfo(nil,nil,true,true,nil,HEX.gold.."Mounts A-E","rae",level,nil)
			gf.setInfo(nil,nil,true,true,nil,HEX.gold.."Mounts F-J","rfj",level,nil)
			gf.setInfo(nil,nil,true,true,nil,HEX.gold.."Mounts K-O","rko",level,nil)
			gf.setInfo(nil,nil,true,true,nil,HEX.gold.."Mounts P-T","rpt",level,nil)
			gf.setInfo(nil,nil,true,true,nil,HEX.gold.."Mounts U-Z","ruz",level,nil)
		end
		if UIDROPDOWNMENU_MENU_VALUE == "swimming" then
			for i=1,#ga.mount do
				local creatureName, icon, issummoned, air, special, fast, water, enabled = unpack(ga.mount[i])
				if water and enabled then
					local checked, func
					checked = gf.Mounts.isSummoned(i)
					func = function() gf.Mounts.summon(i) end;
					--disabled,isTitle,hasArrow,notCheckable,checked,text,value,level,func
					gf.setInfo(nil,false,false,false,checked,creatureName,name,level,func,icon)
				end
			end
		end
	end
	if (level == 3) then
		for i=1,#ga.mount do
			local creatureName, icon, issummoned, air, special, fast, water, enabled = unpack(ga.mount[i])
			if ga.alphabet[strlower(string.sub(creatureName,1,1))] == string.sub(UIDROPDOWNMENU_MENU_VALUE,2) and enabled then
				if string.sub(UIDROPDOWNMENU_MENU_VALUE,1,1) == "f" then
					if (air or special) and enabled then
						local checked, func
						checked = gf.Mounts.isSummoned(i)
						func = function() gf.Mounts.summon(i) end;
						--disabled,isTitle,hasArrow,notCheckable,checked,text,value,level,func
						gf.setInfo(nil,false,false,false,checked,creatureName,name,level,func,icon)
					end
				end
				if string.sub(UIDROPDOWNMENU_MENU_VALUE,1,1) == "r" then
					if (not (air or water) or special) and enabled then
						local checked, func
						checked = gf.Mounts.isSummoned(i)
						func = function() gf.Mounts.summon(i) end;
						--disabled,isTitle,hasArrow,notCheckable,checked,text,value,level,func
						gf.setInfo(nil,false,false,false,checked,creatureName,name,level,func,icon)
					end
				end
			end
		end
	end
end

---------------------------
-- options
---------------------------
function gf.Mounts.options()
	local pIDX = gf.createPanel("Mounts","Select which mounts you wish to be visible on the mounts menu.",function(self) gv.overflowFix = true end)
	gv.MountScrollIDX = gf.createScrollBar(_G["Glance_Panel"..pIDX],18,-70,345,378,20,ga.mount,1,8,gf.Mounts.setPreferredMount)
	local pIDX = gf.createPanel("Macros","The following macros can be made to randomize your mounts.  The choice of mount is determined by your settings in the Mounts panel.",nil)
	gf.createText(pIDX,15,-60,"/glance random","GameFontNormal","")
	gf.createText(pIDX,15,-75,"Summons a random mount best suited for the area you are in.","GameFontHighlight","")
	gf.createText(pIDX,15,-110,"/glance randomair","GameFontNormal","")
	gf.createText(pIDX,15,-125,"Summons a random flying mount.","GameFontHighlight","")
	gf.createText(pIDX,15,-160,"/glance randomland","GameFontNormal","")
	gf.createText(pIDX,15,-175,"Summons a random land mount.","GameFontHighlight","")
	gf.createText(pIDX,15,-210,"/glance randomwater","GameFontNormal","")
	gf.createText(pIDX,15,-225,"Summons a random water mount.","GameFontHighlight","")
end

---------------------------
-- mount scrollbar click
---------------------------
function gf.Mounts.setPreferredMount(line)
	local pref, name
	--for line=1,20 do
		name = _G[getglobal("Glance_SBE"..gv.MountScrollIDX..line):GetName().."Text"]:GetText()
		pref = _G["Glance_SBE"..gv.MountScrollIDX..line]:GetChecked()
		if pref == 1 then
			pref = true
		else
			pref = false
		end
		if name ~= nil then
			spc.Mounts[name] = pref
		end
	--end
	gf.Mounts.resetMountList()
end

---------------------------
-- is summoned
---------------------------
function gf.Mounts.isSummoned(id)
	local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("MOUNT", id);
	return issummoned
end

---------------------------
-- summon
---------------------------
function gf.Mounts.summon(id)
	local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("MOUNT", id);
	if issummoned then
		DismissCompanion("MOUNT")
	else
		CallCompanion("MOUNT",id)
	end
end

---------------------------
-- get mount info
---------------------------
function gf.Mounts.mountInfo(id)
	CreateFrame("GameTooltip","Glance_Tooltip_Mount",UIParent,"GameTooltipTemplate")
	GameTooltip_SetDefaultAnchor(Glance_Tooltip_Mount, UIParent)
	local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("MOUNT", id);
	local special, air, fast = false, false, false
	Glance_Tooltip_Mount:SetHyperlink("spell:"..creatureSpellID)
	air = gf.Mounts.airMounts()
	special = gf.Mounts.specialMounts()
	water = gf.Mounts.waterMounts()
	fast = special or gf.Mounts.fastMounts() 
	Glance_Tooltip_Mount:Hide();
	local showMount = true
	if spc.Mounts[creatureName] ~= nil then
		showMount = spc.Mounts[creatureName]
	end
	return creatureName, icon, issummoned, air, special, fast, water, showMount
end

---------------------------
-- search for flying mounts
---------------------------
function gf.Mounts.airMounts()
	local air = false
	for i=1, #ga.flightMounts do
		air = gf.match(Glance_Tooltip_Mount:NumLines(),"Glance_Tooltip_MountTextLeft",ga.flightMounts[i])
		if air then return true end
	end
	return false
end

---------------------------
-- search for special mounts
---------------------------
function gf.Mounts.specialMounts()
	local special = false
	for i=1, #ga.specialMounts do
		special = gf.match(Glance_Tooltip_Mount:NumLines(),"Glance_Tooltip_MountTextLeft",ga.specialMounts[i])
		if special then return true end
	end
	return false
end

---------------------------
-- search for fastmounts
---------------------------
function gf.Mounts.fastMounts()
	local fast = false
	for i=1, #ga.fastMounts do
		fast = gf.match(Glance_Tooltip_Mount:NumLines(),"Glance_Tooltip_MountTextLeft",ga.fastMounts[i])
		if fast then return true end
	end
	return false
end

---------------------------
-- search for water mounts
---------------------------
function gf.Mounts.waterMounts()
	local water = false
	for i=1, #ga.waterMounts do
		water = gf.match(Glance_Tooltip_Mount:NumLines(),"Glance_Tooltip_MountTextLeft",ga.waterMounts[i])
		if water then return true end
	end
	return false
end

---------------------------
-- store mounts in {}
---------------------------
function gf.Mounts.resetMountList()
	Glance.Debug("function","resetMountList",nil)
	wipe(ga.mount)
	local mountListChanged = false
	for i=1,GetNumCompanions("MOUNT") do
		ga.mount[i] = { gf.Mounts.mountInfo(i) }
		if spc.Mounts[ga.mount[i][1]] == nil then
			spc.Mounts[ga.mount[i][1]] = true
			mountListChanged = true
		end
	end
	if mountListChanged then gf.sendMSG("Your mount list has changed.  Type '/glance options' to reconfigure your preferences.") end
end

---------------------------
-- battleground status
---------------------------
function gf.Mounts.inBattleground()
	local pvpID, localizedName, isActive, canQueue, sec, canEnter = GetWorldPVPAreaInfo(1)
	if (isActive and GetZoneText()=="Wintergrasp") then
		return true;
	end
	pvpID, localizedName, isActive, canQueue, sec, canEnter = GetWorldPVPAreaInfo(2)
	if (isActive and GetZoneText()=="Tol Barad") then
		return true;
	end
	return false;
end

---------------------------
-- summon a random mount
---------------------------
function gf.Mounts.summonRandom()
	Glance.Debug("function","summon","Random")
	if IsOutdoors() then
		if IsSwimming() then
			if strfind(GetMapInfo(),"Vashj") then
				gf.Mounts.summonRandomWater()
			elseif strfind(GetMapInfo(),"Thousand") then
				gf.Mounts.summonRandomWater()
			else 
				gf.Mounts.summonRandomWater()
			end
		else
			if (IsFlyableArea() and not gf.Mounts.inBattleground()) then
				gf.Mounts.summonRandomAir()
			else
				gf.Mounts.summonRandomLand()
			end
		end
	end
end

---------------------------
-- summon a random air mount
---------------------------
function gf.Mounts.summonRandomAir()
	local mountCount = 0
	for i=1,#ga.mount do
		local creatureName, icon, issummoned, air, special, fast, water, enabled = unpack(ga.mount[i])
		local pvpID, localizedName, isActive, canQueue, sec, canEnter = GetWorldPVPAreaInfo(1)
		ga.mount[i][3] = false
		if (air or special) and enabled then
			mountCount = mountCount + 1
			ga.tmpmount[mountCount] = i
		end
	end
	gf.Mounts.Randomize("Air")
end

---------------------------
-- summon a random land mount
---------------------------
function gf.Mounts.summonRandomLand()
	local mountCount = 0
	for i=1,#ga.mount do
		local creatureName, icon, issummoned, air, special, fast, water, enabled = unpack(ga.mount[i])
		ga.mount[i][3] = false
		if not (air or water) and enabled then
			if strfind(creatureName,"Qiraji") then
				if strfind(GetMapInfo(),"Qiraj") then
					mountCount = mountCount + 1
					ga.tmpmount[mountCount] = i
				end
			else
				mountCount = mountCount + 1
				ga.tmpmount[mountCount] = i
			end
		end
	end
	gf.Mounts.Randomize("Land")
end

---------------------------
-- summon a random water mount
---------------------------
function gf.Mounts.summonRandomWater()
	local mountCount = 0
	for i=1,#ga.mount do
		local creatureName, icon, issummoned, air, special, fast, water, enabled = unpack(ga.mount[i])
		ga.mount[i][3] = false
		if water and enabled then
			mountCount = mountCount + 1
			ga.tmpmount[mountCount] = i
		end
	end
	gf.Mounts.Randomize("Water")
end

---------------------------
-- randomize
---------------------------
function gf.Mounts.Randomize(which)
	if #ga.tmpmount > 0 then
		local rdm = ga.tmpmount[random(1,#ga.tmpmount)]
		ga.mount[rdm][3] = true
		CallCompanion("MOUNT",rdm)
		Glance.Debug("function","summon","Random"..which..": "..ga.mount[rdm][1])
	end
	wipe(ga.tmpmount)
end

---------------------------
-- load on demand
---------------------------
if gv.loaded then
	gf.Enable("Mounts")
end